The "src" folder is the source code of SAMI paper which has seen some minor changes 
from the original received version.
The "codes" folder is the folder containing the following files: 
1.adjlisttext_tonxgraph.py: gets an adj. list as input file and gives out the visualized
 graph
2.mat_tonxgraph.py: gets a .mat file as input file and gives out the visualized graph
3.mae.py: computes mae of two graphs given their .mat adj matrix file

For using the source code you must pay attention to two files: "RunExpSrv8s" and 
"MissingNodes_S8b". The first one is the function which sets up the files and 
calls the main function i.e. "MissingNodes_S8b".


For having your own dataset run on this code you should know the below variables:

*RUNEXPSRV_8S.m
1. num_missing_nodes_arr: number of randomly removed nodes on each iteration
2. ds_*: array of node numbers of your input arr
3. ds_str: dataset path as a string
4. root_dir
5. file_prefix: file name prefix of the input files

*MISSINGNODES_S8B
1. k: filename postfix for saving
2. clusters_out: true and predicted graph saved as .mat file
3. graphs_out: 4 graphs including {original, predicted, predicted permuted, 
original permuted} as .mat file


*grid dataset is run on the src code as an example